import 'package:eyflutter_core/event/on_eyflutter_config.dart';
import 'package:eyflutter_core/kit/parts/config_manager.dart';

class EyFlutter {
  factory EyFlutter() => _getInstance();

  static EyFlutter get instance => _getInstance();
  static EyFlutter? _instance;

  static EyFlutter _getInstance() {
    return _instance ??= new EyFlutter._internal();
  }

  EyFlutter._internal();

  String _eyConfigKey = "f0b4595909fb23aa";

  /// OnEyFlutterConfig实现类
  void registerConfig<T extends OnEyFlutterConfig>(T? config) {
    if (config == null) {
      return;
    }
    ConfigManager.instance.addConfig(_eyConfigKey, config);
  }

  OnEyFlutterConfig? _getEyFlutterConfig() {
    var config = ConfigManager.instance.getConfig(_eyConfigKey);
    if (config is! OnEyFlutterConfig) {
      return null;
    }
    return config;
  }

  OnEyFlutterConfig? get applicationConfig => _getEyFlutterConfig();
}
